//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Disp.h"
#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm4 *Form4;

int Range,EFlg;
int Color;
int NoFlg,StX,StY;

extern Graphics::TBitmap *BMP,*BMP0;
extern int Mx,My,Cx,Cy,ImgW,ImgH;;
extern void Correct_End();
//---------------------------------------------------------------------------
__fastcall TForm4::TForm4(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
int Get_Color(int x,int y)
{
  int color;
  int r,g,b,r0,g0,b0;

   r0=0;
   g0=0;
   b0=0;

     color=Form4->Image1->Canvas->Pixels[x][y];
     r=color&0x00ff0000;
     g=color&0x0000ff00;
     b=color&0x000000ff;
     r0=r0+r;
     g0=g0+g;
     b0=b0+b;

     color=Form4->Image1->Canvas->Pixels[x][y+1];
     r=color&0x00ff0000;
     g=color&0x0000ff00;
     b=color&0x000000ff;
     r0=r0+r;
     g0=g0+g;
     b0=b0+b;

     if((y-1)<My)
      color=Form4->Image1->Canvas->Pixels[x][y];
     else
      color=Form4->Image1->Canvas->Pixels[x][y-1];

     r=color&0x00ff0000;
     g=color&0x0000ff00;
     b=color&0x000000ff;
     r0=r0+r;
     g0=g0+g;
     b0=b0+b;

     if((x-1)<Mx)
      {
       color=Form4->Image1->Canvas->Pixels[x][y];
      }
     else
      color=Form4->Image1->Canvas->Pixels[x-1][y];

     r=color&0x00ff0000;
     g=color&0x0000ff00;
     b=color&0x000000ff;
     r0=r0+r;
     g0=g0+g;
     b0=b0+b;


     color=Form4->Image1->Canvas->Pixels[x+1][y];
     r=color&0x00ff0000;
     g=color&0x0000ff00;
     b=color&0x000000ff;
     r0=r0+r;
     g0=g0+g;
     b0=b0+b;

  r=(r0/5)&0x00ff0000;
  g=(g0/5)&0x0000ff00;
  b=(b0/5)&0x000000ff;
  color=r+g+b;
  return color;
}

void Set_Pix2(int color)
{
 for(int i=0;i<30;i++)
  {
   for(int ii=0;ii<30;ii++)
   {
     Form4->Image2->Canvas->Pixels[i][ii]=TColor(color);
   }
  }
}
void Set_Pix0(int color,int x,int y)
{
 if(NoFlg==255) return;

 for(int i=0;i<10;i++)
  {
   for(int ii=0;ii<10;ii++)
   {
     Form4->Image1->Canvas->Pixels[x+i][y+ii]=TColor(color);
   }
  }

 x=Cx+x/10;
 y=Cy+y/10;

 BMP->Canvas->Pixels[x][y]=TColor(color) ;
 Disp_F->Image1->Picture->Assign(BMP);
 Disp_F->Image1->Update();

}
void Pr_Edit0()
{
 TRect rect0,rect1;
 Graphics::TBitmap *bmp;

 BMP0->Assign(BMP);

 bmp=new Graphics::TBitmap;
 Form4->Image1->Canvas->Pen->Mode=pmCopy;

 bmp->Width=100;
 bmp->Height=100;

 rect1.Top=0;
 rect1.Left=0;
 rect1.Right=100;
 rect1.Bottom=100;

 int x=StX=Mx;
 int y=StY=My;

 Cx=x; Cy=y;

 rect0.Top=y;
 rect0.Left=x;
 rect0.Right=100+x;
 rect0.Bottom=100+y;

 bmp->Canvas->CopyRect(rect1,Disp_F->Image1->Picture->Bitmap->Canvas,rect0);

 Form4->Image1->Canvas->StretchDraw(Rect(0,0,1000, 1000),bmp);

 delete bmp;
}

void __fastcall TForm4::FormActivate(TObject *Sender)
{
 EFlg=255;
 Range=1;
 RadioButton3->Checked=true;

 switch(EFlg)
  {
   case 255:
    RadioButton1->Checked=true;
    EFlg=255;
    break;
   case 250:
    RadioButton2->Checked=false;
    Image2->Visible=true;
    Set_Pix2(Color);
    break;
  }

 Form4->Image1->Top=0;
 Form4->Image1->Left=0;
 Form4->ScrollBox1->VertScrollBar->Position=0;
 Form4->ScrollBox1->HorzScrollBar->Position=0;
 Pr_Edit0();
}
//---------------------------------------------------------------------------
void contrast(int x,int y,TShiftState Shift)
{
  int color;
  int r,g,b;

    color=Form4->Image1->Canvas->Pixels[x][y];
    r=color&0x00ff0000;
    g=color&0x0000ff00;
    b=color&0x000000ff;

    if(Shift.Contains(ssLeft))
     {
      if(Form4->RadioButton7->Checked==true)
       {
         r=r+0x00050000;
         g=g+0x00000500;
         b=b+0x00000005;
       }
      else
       {
         r=r+0x00100000;
         g=g+0x00001000;
         b=b+0x00000010;
       }
      if(r>0x00ff0000) r=0x00ff0000;
      if(g>0x0000ff00) g=0x0000ff00;
      if(b>0x000000ff) b=0x000000ff;
     }
    else
     {
      if(Form4->RadioButton7->Checked==true)
       {
        r=r-0x00050000;
        g=g-0x00000500;
        b=b-0x00000005;
       }
      else
       {
        r=r-0x00100000;
        g=g-0x00001000;
        b=b-0x00000010;
       }

      if(r<0x00010000) r=0;
      if(g<0x00000100) g=0;
      if(b<0x00000001) b=0;
     }

    color=r+g+b;
    Set_Pix0(color,x,y);
}
void __fastcall TForm4::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  int x,y,i,ii;

  Mx=X;
  My=Y;
  x=(X/10)*10;
  y=(Y/10)*10;

  switch(EFlg)
  {
   case 255:
    for(i=0;i<Range*10;i=i+10)
     {
      for(ii=0;ii<Range*10;ii=ii+10)
       {
        contrast(x+i,y+ii,Shift);
       }
     }
    break;

   case 250:
     if(Shift.Contains(ssLeft))
      {
        for(i=0;i<Range*10;i=i+10)
         {
          for(ii=0;ii<Range*10;ii=ii+10)
           {
            Set_Pix0(Color,x+i,y+ii);
           }
         }
      }
     else
      {
        Color=Image1->Canvas->Pixels[X][Y];
        Set_Pix2(Color);
      }
    break;
   case 240:
    if(Shift.Contains(ssLeft))
      {


       for(i=0;i<Range*10;i=i+10)
         {
          for(ii=0;ii<Range*10;ii=ii+10)
           {
            Color=TColor(Get_Color(x+i,y+ii));
            Set_Pix0(Color,x+i,y+ii);
           }
         }
      }

    break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm4::Button1Click(TObject *Sender)
{
 Form4->Image1->Top=0;
 Form4->Image1->Left=0;
 Form4->ScrollBox1->VertScrollBar->Position=0;
 Form4->ScrollBox1->HorzScrollBar->Position=0;
 Close();
 Mx=0;
 My=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm4::RadioButton1Click(TObject *Sender)
{
  EFlg=255;
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton2Click(TObject *Sender)
{
 EFlg=250;
  
}
//---------------------------------------------------------------------------

void __fastcall TForm4::FormResize(TObject *Sender)
{
  Form4->Width=676;
  Form4->Height=480;      
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton3Click(TObject *Sender)
{
  Range=1;      
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton4Click(TObject *Sender)
{
  Range=3;      
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton5Click(TObject *Sender)
{
  Range=2;
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton6Click(TObject *Sender)
{
  EFlg=240;
}
//---------------------------------------------------------------------------

void __fastcall TForm4::Image1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{

  if(((X/10+StX)>ImgW)|| ((Y/10+StY)>ImgH))
   {
     Screen->Cursor=crNo;
     NoFlg=255;
   }
  else
   {
    Screen->Cursor=crArrow;
    NoFlg=0;
   }

}
//---------------------------------------------------------------------------

void __fastcall TForm4::Panel1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  Screen->Cursor=crArrow;
}
//---------------------------------------------------------------------------

void __fastcall TForm4::Button2Click(TObject *Sender)
{
  ColorDialog1->Execute();
  Color=ColorDialog1->Color;
  Set_Pix2(Color);
}
//---------------------------------------------------------------------------

void __fastcall TForm4::RadioButton8Click(TObject *Sender)
{
   Range=5;
}
//---------------------------------------------------------------------------


