//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit6.h"
#include "Disp.h"
#include "Unit7.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm6 *Form6;

extern int EllipseP,EllipseR,EllipseX[],EllipseY[],Make_FLG;
extern AnsiString FNAM;
extern void Ellipse_Drw();

AnsiString Tmp;

//---------------------------------------------------------------------------
__fastcall TForm6::TForm6(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
class MK_NAME
{
  private:
   int i,p0,p1;
   AnsiString Path0[10],Path1[10],fname,w,c;

   void sep_path(AnsiString,AnsiString);
   void extract_path(int);
   void cmp_path();
  public:
   MK_NAME(){ ; };
   AnsiString Mk_Name(AnsiString,AnsiString);

};
void MK_NAME::extract_path(int flg)
{
  int len;
  AnsiString w1;

  len=w.Length();

  w1="";

  for(i=1;i<=len;i++)
   {
    c=w.SubString(i,1);
    if(c=="\\")
     {
      if(flg==0)
       {  Path0[p0]=w1; p0++;   }
      else
       {  Path1[p1]=w1; p1++;   }
      w1="";
     }
    else
     { w1=w1+c; }
   }
}

void MK_NAME::sep_path(AnsiString fnam,AnsiString tmp)
{
  fname=ExtractFileName(tmp);
  w=ExtractFilePath(fnam);
  extract_path(0);
  w=ExtractFilePath(tmp);
  extract_path(1);
}

void MK_NAME::cmp_path()  //Path0[],Path1[],p1,p0 Zbgς
{
  int pos;

  w="";

  if(p0>p1)
   { pos=p1; }
  else
   { pos=p0; }

  for(i=0;i<pos;i++)
   {
    if(Path0[i] != Path1[i])     break;
   }

  if(i==pos)
   {  w="./"+fname;    }
  else
   {
    if((p0-i)==0)
     {
      if((p1-i)==0)
       {  w="./"+fname;    }
      else
       {
         w="";
         for(i=i;i<p0;i++)
          {
            w=w+"../";
          }
         w=w+fname;
       }
     }
    else
     {
      for(i=i;i<p1;i++)
       {
        w=w+Path1[i];
        w=w+"/";
       }
      w=w+fname;
     }
   }
}
AnsiString MK_NAME::Mk_Name(AnsiString f0,AnsiString f1)
{
 p0=0; p1=0;
 MK_NAME::sep_path(f0,f1);
 MK_NAME::cmp_path();

 return w;
}

MK_NAME MN;
//---------------------------------------------------------------------------

void NewSave()
{ AnsiString txt,FileName;
  int len;
  HFILE hfil;

  Form6->SaveDialog1->FileName=FileName;

  if(Form6->SaveDialog1->Execute()==true)
    {
     FileName=Form6->SaveDialog1->FileName;
     txt=Form6->RichEdit1->Text;
     len=txt.Length();
     hfil=_lcreat(Form6->SaveDialog1->FileName.c_str(),0);
     _lwrite(hfil,txt.c_str(),len);
     _lclose(hfil);

    }
}

void __fastcall TForm6::FormActivate(TObject *Sender)
{
 AnsiString W,R,t0,t1;
 int i;

 RichEdit1->Clear();

 W="<HTML>\r\n<HEAD>\r\n";
 W=W+"<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">";
 W=W+"\r\n<META http-equiv=\"Content-Style-Type\" content=\"text/css\">";
 W=W+"\r\n<META NAME=\"Keywords\"  CONTENT=\"\">";
 W=W+"\r\n<META NAME=\"description\"  CONTENT=\"\">\r\n" ;
 W=W+"<TITLE>MAP</TITLE>\r\n</HEAD>\r\n";
 W=W+"<BODY BGCOLOR=#FFFFF0 TEXT=#0000FF LINK=#FF0000 VlINK=#000000>\r\n\r\n";

 W=W+"<MAP NAME=\"ndx\">\r\n";

 for(i=0;i<EllipseP;i++)
 {

   W=W+"<AREA SHAPE=CIRCLE COORDS=\"";
   t0=IntToStr(EllipseX[i]);
   W=W+t0;
   W=W+",";
   t1=IntToStr(EllipseY[i]);
   W=W+",";
   W=W+t1;
   W=W+",";

   R=IntToStr(EllipseR);
   W=W+R;
   W=W+"\"";

   W=W+" HREF=\"";
   W=W+"\">\r\n";

  }

 W=W+"</MAP>\r\n";

 W=W+"<IMG SRC=\"";
 W=W+FNAM;
 W=W+"\" ALIGN=BOTTOM USEMAP=\"#ndx\">\r\n\r\n";
 W=W+"</BODY>\r\n</HTML>\r\n";

 RichEdit1->SetSelTextBuf(W.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm6::N2Click(TObject *Sender)
{
  int p,i;

   Form6->Enabled=false;
   Form6->Visible=false;

  p=EllipseP;
  for(i=0;i<p;i++)
   {
    EllipseP=i+1;
    Ellipse_Drw();
   }

   Make_FLG=0;
   EllipseP=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm6::N1Click(TObject *Sender)
{
  NewSave();
  RichEdit1->Modified=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm6::N3Click(TObject *Sender)
{
  RichEdit1->CopyToClipboard();       
}
//---------------------------------------------------------------------------

void __fastcall TForm6::N4Click(TObject *Sender)
{
  AnsiString w0,w1;

  Tmp="";
  w0=FNAM;

  Form7->ShowModal();

  if(Tmp!="")
   {
    Tmp=MN.Mk_Name(FNAM,Tmp);

    RichEdit1->SetSelTextBuf(Tmp.c_str());
   }
}
//---------------------------------------------------------------------------

